/////////////////////////////////////////////////////////////////////////////
//
// Written by Igor Tolmachev (support@itsamples.com)
// Copyright (c) 2017 Igor Tolmachev.
//
// This code may be used in compiled form in any way you desire. This
// source file may be redistributed by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. 
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability if it causes any damage to you or your
// computer whatsoever. It's free, so don't hassle me about it.
//
// Beware of bugs.
//

// MainDlg.cpp : implementation of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"
#include "AboutDlg.h"
#include "MainDlg.h"

LRESULT CMainDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
    // center the dialog on the screen
    CenterWindow();

    m_pViewDlg = NULL;

    // set icons
    HICON hIcon = AtlLoadIconImage(IDR_MAINFRAME, LR_DEFAULTCOLOR, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON));
    SetIcon(hIcon, TRUE);
    HICON hIconSmall = AtlLoadIconImage(IDR_MAINFRAME, LR_DEFAULTCOLOR, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON));
    SetIcon(hIconSmall, FALSE);

    m_wndTreeCtrl.SubclassWindow(GetDlgItem(IDC_TREE_EXPLORER));

    CMessageLoop* pLoop = _Module.GetMessageLoop();
    ATLASSERT(pLoop != NULL);
    pLoop->AddMessageFilter(this);
    pLoop->AddIdleHandler(this);

    UIAddChildWindowContainer(m_hWnd);

    HMENU hSysMenu = GetSystemMenu(FALSE);
    if (hSysMenu != NULL)
    {
        AppendMenu(hSysMenu, MF_SEPARATOR, MF_SEPARATOR, NULL);
        AppendMenu(hSysMenu, MF_BYCOMMAND | MF_STRING, ID_APP_ABOUT, _T("About SRV Explorer..."));
    }

    return TRUE;
}

LRESULT CMainDlg::OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    if ((wParam & 0xFFF0) == ID_APP_ABOUT)
    {
        CAboutDlg dlg;
        dlg.DoModal();
    }

    bHandled = FALSE;

    return 0;
}

LRESULT CMainDlg::OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
    DestroyWindow();
    ::PostQuitMessage(wID);

    return 0;
}

LRESULT CMainDlg::OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
    DestroyWindow();
    ::PostQuitMessage(wID);

    return 0;
}

LRESULT CMainDlg::OnFileItemSelected(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
    LPTSTR pszFileName = (LPTSTR)lParam;
    if(pszFileName)
    {
        if(m_pViewDlg)
        {
            m_pViewDlg->ShowFile(pszFileName);
        }
        else
        {
            m_pViewDlg = new CViewDlg(pszFileName);
            m_pViewDlg->Create(m_hWnd);
        }

        m_pViewDlg->ShowWindow(SW_SHOW);
    }

    return TRUE;
}
